
TYPO3.Flow - Bug # 34672

Status: Resolved Priority: Must have
Author: Kira Backes Category: Reflection
Created: 2012-03-08 Assigned To: Karsten Dambekalns
Updated: 2012-04-27 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: Production context is not working
Description

When running an application (that uses Collections) in Production context the following exception is thrown:

  Catchable Fatal Error: Argument 2 passed to
  TYPO3\FLOW3\Validation\Validator\GenericObjectValidator_Original::addPropertyValidator()
  must implement interface
  TYPO3\FLOW3\Validation\Validator\ValidatorInterface, null given, called
  in
 
/var/development/flow3/finderON/Data/Temporary/Production/Cache/Code/FLOW3_Object_Classes/TYPO3_FLOW3_Validation_ValidatorResolver_Original.php
  on line 240 and defined in
  /var/development/flow3/finderON/Data/Temporary/Production/Cache/Code/FLOW3_Object_Classes/TYPO3_FLOW3_Validation_Validator_GenericObjectValidator_Original.php
  line 148

n_ValidatorResolver_Original.php
  on line 240 and defined in
 
/var/development/flow3/finderON/Data/Temporary/Production/Cache/Code/FLOW3_Object_Classes/TYPO3_FLOW3_Validation_Validator_GenericObjectValidator_Original.php
  line 148

n_Validator_GenericObjectValidator_Original.php
  line 148

.

Can be fixed by changing TYPO3\FLOW3\Reflection\ReflectionService.php:433
(Method isClassImplementationOf)

        $this->loadOrReflectClassIfNecessary($className);

to

        $this->loadOrReflectClassIfNecessary($className);
        $this->loadOrReflectClassIfNecessary($interfaceName);

Associated revisions
Revision e40b2219 - 2012-04-27 12:49 - Karsten Dambekalns

[BUGFIX] Fix isClassImplementationOf in ReflectionService

In some cases (depending on filesystem load order probably) the
Production context would fail to return the correct result in the
isClassImplementationOf() method of the ReflectionService.

This change fixes it.

Change-Id: I4b750ec8975b559340596e01c9ee8bee5515edde
Fixes: #34672
Releases: 1.1

History
#1 - 2012-03-08 16:47 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#2 - 2012-03-08 16:48 - Karsten Dambekalns
- Category set to Reflection
- Status changed from New to Needs Feedback
- Assigned To set to Karsten Dambekalns
- Target version set to 1.1
- Has patch set to No

Makes sense - could the problem be distilled into a functional test?

#3 - 2012-04-27 12:49 - Karsten Dambekalns
- Status changed from Needs Feedback to Accepted

#4 - 2012-04-27 12:50 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/10820

#5 - 2012-04-27 14:38 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:e40b22193fe0a52b24f090e1cb16b095cacea1d9.
